require "buildable/version"

module RubyRising
  module Buildable
    def build(&block)
      yield self if block_given?
      return self
    end #TT

    def self.included(base)
      if base.class == Class
        add_class_build_method(base)
      end
    end #NT

    def self.add_class_build_method(base)
      base.instance_eval do
        def self.build(&block)
          new.build(&block)
        end #TT
      end
    end

  end
end
