require 'spec_helper'

class BuildableClass
  include RubyRising::Buildable
end

RSpec.describe RubyRising::Buildable do
  let(:buildable_class){ BuildableClass }
  subject { BuildableClass.new }

  it "has a version number" do
    expect(RubyRising::Buildable::VERSION).not_to be nil
  end

  describe '#build' do
    it 'yields itself to a block if a block is given' do
      expect{ |spec| subject.build(&spec) }.to yield_with_args(subject)
    end
    it 'returns itself (and works when called without a block)' do
      expect(subject.build).to be(subject)
    end
  end

  describe '.build' do
    it 'creates a new instance and then works the same way as #build' do
      buildable_class.build do |object|
        expect(object).to be_an_instance_of(buildable_class)
      end
      expect(buildable_class.build).to be_an_instance_of(buildable_class)
    end
  end
end
