require_relative 'case_conversion/version'

module RubyRising
  module CaseConversion
    @@conversions = {
      snake_case: ->(string){
        string.gsub(/::/, '/').
        gsub(/([A-Z]+)([A-Z][a-z])/,'\1_\2').
        gsub(/([a-z\d])([A-Z])/,'\1_\2').
        tr("-", "_").
        downcase
      },
      camel_case: ->(string){
        string.split("_").map(&:capitalize).join("")
      },
      lower_camel_case: ->(string){
        string.split('_').inject([]){ |buffer,e| buffer.push(buffer.empty? ? e : e.capitalize) }.join
      }
    }

    def convert_case_of(string, to:)
      @@conversions[to].(string)
    end
  end
end
