require 'spec_helper'

module ConfigurableModule
  extend RubyRising::Configurable
end

class ConfigurableModule::Configuration; end

RSpec.describe RubyRising::Configurable do

  it "has a version number" do
    expect(RubyRising::Configurable::VERSION).not_to be nil
  end

  describe "#configuration" do
    it 'returns an instance of the module\'s configuration class' do
      expect(ConfigurableModule.configuration).to be_an_instance_of(ConfigurableModule::Configuration)
    end
    it 'always returns the same instance of the configuration class' do
      expect(ConfigurableModule.configuration).to be(ConfigurableModule.configuration)
    end
  end

  describe "#reset!" do
    it 'resets the instance of configuration' do
      old_config = ConfigurableModule.configuration
      ConfigurableModule.reset!
      expect(ConfigurableModule.configuration).to_not be(old_config)
      expect(ConfigurableModule.configuration).to be_an_instance_of(ConfigurableModule::Configuration)
    end
  end

  describe "#configure" do
    it 'yields the configuration class to the block given' do
      expect{ |spec| ConfigurableModule.configure(&spec) }.to yield_with_args(ConfigurableModule.configuration)
    end
  end
end
