require 'injectable/version'
require 'injectable/injection_helper'
require 'configurable'
require_relative 'injectable/configuration'

module RubyRising
  module Injectable
    extend RubyRising::Configurable

    def instance_inject(variables, black_list: [])
      variables.each do |key, value|
        next if RubyRising::Injectable.configuration.black_list.include? key
        next if black_list.include? key
        instance_variable_set(key, value)
      end
    end
  end
end
